Index: /trunk/include/iprt/cdefs.h
===================================================================
--- /trunk/include/iprt/cdefs.h	(revision 15931)
+++ /trunk/include/iprt/cdefs.h	(revision 15932)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2007 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2009 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -101,5 +101,5 @@
 #  define RT_ARCH_X86
 # else /* PORTME: append test for new archs. */
-#  error "Check what predefined stuff your compiler uses to indicate architecture."
+#  error "Check what predefined macros your compiler uses to indicate architecture."
 # endif
 #elif defined(RT_ARCH_X86) && defined(RT_ARCH_AMD64) /* PORTME: append new archs. */
@@ -123,5 +123,5 @@
 #  define __X86__
 # else
-#  error "Check what predefined stuff your compiler uses to indicate architecture."
+#  error "Check what predefined macros your compiler uses to indicate architecture."
 # endif
 #elif defined(__X86__) && defined(__AMD64__)
@@ -148,5 +148,5 @@
  */
 #if !defined(IN_RING3) && !defined(IN_RING0) && !defined(IN_RC) && !defined(IN_RC)
-# error "You must defined which context the compiled code should run in; IN_RING3, IN_RING0 or IN_RC"
+# error "You must define which context the compiled code should run in; IN_RING3, IN_RING0 or IN_RC"
 #endif
 #if (defined(IN_RING3) && (defined(IN_RING0) || defined(IN_RC)) ) \
@@ -250,5 +250,5 @@
 
 /** @def R3R0PTRTYPE
- * Declare a pointer which is used in HC, is explicitely valid in ring 3 and 0,
+ * Declare a pointer which is used in HC, is explicitly valid in ring 3 and 0,
  * but appears in structure(s) used by both HC and GC. The main purpose is to
  * make sure structures have the same size when built for different architectures.
@@ -281,5 +281,5 @@
  * identifier name. The suffix is HC or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   var     Identifier name.
  * @deprecated Use CTX_SUFF. Do NOT use this for new code.
@@ -289,5 +289,5 @@
  * identifier name. The suffix is HC or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   var     Identifier name.
  * @deprecated Use CTX_SUFF. Do NOT use this for new code.
@@ -305,5 +305,5 @@
  * identifier name. The suffix is R3, R0 or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   var     Identifier name.
  * @deprecated Use CTX_SUFF. Do NOT use this for new code.
@@ -321,5 +321,5 @@
  * identifier name. The suffix is R3, R0 or RC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   var     Identifier name.
  *
@@ -339,5 +339,5 @@
  * The suffix thus is R3 or RZ.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   var     Identifier name.
  *
@@ -355,5 +355,5 @@
  * The middle name is HC or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   first   First name.
  * @param   last    Surname.
@@ -363,5 +363,5 @@
  * The middle name is HC or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   first   First name.
  * @param   last    Surname.
@@ -380,5 +380,5 @@
  * The middle name is R3, R0 or GC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   first   First name.
  * @param   last    Surname.
@@ -397,5 +397,5 @@
  * The middle name is R3, R0 or RC.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   first   First name.
  * @param   last    Surname.
@@ -414,5 +414,5 @@
  * The middle name thus is either R3 or RZ.
  *
- * This is macro should only be used in shared code to avoid a forrest of ifdefs.
+ * This is macro should only be used in shared code to avoid a forest of ifdefs.
  * @param   first   First name.
  * @param   last    Surname.
@@ -649,5 +649,5 @@
 
 /** @def IN_RT_STATIC
- * Used to inidicate whether we're linking against a static IPRT
+ * Used to indicate whether we're linking against a static IPRT
  * or not. The IPRT symbols will be declared as hidden (if
  * supported). Note that this define has no effect without setting
@@ -746,5 +746,5 @@
  * decorate the symbols such that they don't conflict the ones in the
  * other CRTs. The result of such conflicts / duplicate symbols can
- * confuse the dynamic loader on unix like systems.
+ * confuse the dynamic loader on Unix like systems.
  *
  * Define RT_WITHOUT_NOCRT_WRAPPERS to drop the wrapping.
@@ -788,7 +788,7 @@
  *
  *      - These macros are meant to be used in places that get executed a lot. It
- *        is wasteful to make predictions in code that is executed seldomly (e.g.
- *        at subsystem initialization time) as the basic block reording that this
- *        affecs can often generate larger code.
+ *        is wasteful to make predictions in code that is executed rarely (e.g.
+ *        at subsystem initialization time) as the basic block reordering that this
+ *        affects can often generate larger code.
  *
  *      - Note that RT_SUCCESS() and RT_FAILURE() already makes use of RT_LIKELY()
@@ -863,5 +863,5 @@
  * @param   uAlignment  The alignment. Power of two!
  * @param   type        Integer type to use while aligning.
- * @remark  This macro is the prefered alignment macro, it doesn't have any of the pitfalls RT_ALIGN has.
+ * @remark  This macro is the preferred alignment macro, it doesn't have any of the pitfalls RT_ALIGN has.
  */
 #define RT_ALIGN_T(u, uAlignment, type) ( ((type)(u) + ((uAlignment) - 1)) & ~(type)((uAlignment) - 1) )
@@ -933,5 +933,5 @@
  * This differs from the usual offsetof() in that it's not relying on builtin
  * compiler stuff and thus can use variables in arrays the structure may
- * contain. If in this usful to determin the sizes of structures ending
+ * contain. This is useful to determine the sizes of structures ending
  * with a variable length field.
  *
@@ -947,5 +947,5 @@
  * This differs from the usual offsetof() in that it's not relying on builtin
  * compiler stuff and thus can use variables in arrays the structure may
- * contain. If in this usful to determin the sizes of structures ending
+ * contain. This is useful to determine the sizes of structures ending
  * with a variable length field.
  *
@@ -1447,5 +1447,5 @@
  *
  * Use this for instrumenting a debugging session only!
- * No comitted code shall use Breakpoint().
+ * No committed code shall use Breakpoint().
  */
 #ifdef __GNUC__