Index: trunk/src/VBox/Devices/Network/slirp/slirp.c
===================================================================
--- trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 15955)
+++ trunk/src/VBox/Devices/Network/slirp/slirp.c	(revision 15956)
@@ -3,7 +3,4 @@
 # include <paths.h>
 #endif
-
-/* disable these counters for the final release */
-/* #define VBOX_WITHOUT_RELEASE_STATISTICS */
 
 #include <VBox/err.h>
@@ -521,5 +518,5 @@
     int i;
 
-    STAM_REL_PROFILE_START(&pData->StatFill, a);
+    STAM_PROFILE_START(&pData->StatFill, a);
 
     nfds = *pnfds;
@@ -552,6 +549,6 @@
         ICMP_ENGAGE_EVENT(&pData->icmp_socket, readfds);
 
-        STAM_REL_COUNTER_RESET(&pData->StatTCP);
-        STAM_REL_COUNTER_RESET(&pData->StatTCPHot);
+        STAM_COUNTER_RESET(&pData->StatTCP);
+        STAM_COUNTER_RESET(&pData->StatTCPHot);
 
         for (so = tcb.so_next; so != &tcb; so = so_next)
@@ -559,5 +556,5 @@
             so_next = so->so_next;
 
-            STAM_REL_COUNTER_INC(&pData->StatTCP);
+            STAM_COUNTER_INC(&pData->StatTCP);
 
             /*
@@ -579,5 +576,5 @@
             if (so->so_state & SS_FACCEPTCONN)
             {
-                STAM_REL_COUNTER_INC(&pData->StatTCPHot);
+                STAM_COUNTER_INC(&pData->StatTCPHot);
                 TCP_ENGAGE_EVENT1(so, readfds);
                 continue;
@@ -590,5 +587,5 @@
             {
                 Log2(("connecting %R[natsock] engaged\n",so));
-                STAM_REL_COUNTER_INC(&pData->StatTCPHot);
+                STAM_COUNTER_INC(&pData->StatTCPHot);
                 TCP_ENGAGE_EVENT1(so, writefds);
             }
@@ -600,5 +597,5 @@
             if (CONN_CANFSEND(so) && so->so_rcv.sb_cc)
             {
-                STAM_REL_COUNTER_INC(&pData->StatTCPHot);
+                STAM_COUNTER_INC(&pData->StatTCPHot);
                 TCP_ENGAGE_EVENT1(so, writefds);
             }
@@ -610,5 +607,5 @@
             if (CONN_CANFRCV(so) && (so->so_snd.sb_cc < (so->so_snd.sb_datalen/2)))
             {
-                STAM_REL_COUNTER_INC(&pData->StatTCPHot);
+                STAM_COUNTER_INC(&pData->StatTCPHot);
                 TCP_ENGAGE_EVENT2(so, readfds, xfds);
             }
@@ -618,6 +615,6 @@
          * UDP sockets
          */
-        STAM_REL_COUNTER_RESET(&pData->StatUDP);
-        STAM_REL_COUNTER_RESET(&pData->StatUDPHot);
+        STAM_COUNTER_RESET(&pData->StatUDP);
+        STAM_COUNTER_RESET(&pData->StatUDPHot);
 
         for (so = udb.so_next; so != &udb; so = so_next)
@@ -625,5 +622,5 @@
             so_next = so->so_next;
 
-            STAM_REL_COUNTER_INC(&pData->StatUDP);
+            STAM_COUNTER_INC(&pData->StatUDP);
 
             /*
@@ -653,5 +650,5 @@
             if ((so->so_state & SS_ISFCONNECTED) && so->so_queued <= 4)
             {
-                STAM_REL_COUNTER_INC(&pData->StatUDPHot);
+                STAM_COUNTER_INC(&pData->StatUDPHot);
                 UDP_ENGAGE_EVENT(so, readfds);
             }
@@ -666,5 +663,5 @@
 #endif
 
-    STAM_REL_PROFILE_STOP(&pData->StatFill, a);
+    STAM_PROFILE_STOP(&pData->StatFill, a);
 }
 
@@ -683,5 +680,5 @@
 #endif
 
-    STAM_REL_PROFILE_START(&pData->StatPoll, a);
+    STAM_PROFILE_START(&pData->StatPoll, a);
 
     /* Update time */
@@ -695,16 +692,16 @@
         if (time_fasttimo && ((curtime - time_fasttimo) >= 2))
         {
-            STAM_REL_PROFILE_START(&pData->StatFastTimer, a);
+            STAM_PROFILE_START(&pData->StatFastTimer, a);
             tcp_fasttimo(pData);
             time_fasttimo = 0;
-            STAM_REL_PROFILE_STOP(&pData->StatFastTimer, a);
+            STAM_PROFILE_STOP(&pData->StatFastTimer, a);
         }
         if (do_slowtimo && ((curtime - last_slowtimo) >= 499))
         {
-            STAM_REL_PROFILE_START(&pData->StatSlowTimer, a);
+            STAM_PROFILE_START(&pData->StatSlowTimer, a);
             ip_slowtimo(pData);
             tcp_slowtimo(pData);
             last_slowtimo = curtime;
-            STAM_REL_PROFILE_STOP(&pData->StatSlowTimer, a);
+            STAM_PROFILE_STOP(&pData->StatSlowTimer, a);
         }
     }
@@ -932,5 +929,5 @@
         if_start(pData);
 
-    STAM_REL_PROFILE_STOP(&pData->StatPoll, a);
+    STAM_PROFILE_STOP(&pData->StatPoll, a);
 }
 
@@ -1067,6 +1064,9 @@
     
     m = m_get(pData);
-    if (m == NULL)
+    if (!m)
+    {
         LogRel(("can't allocate new mbuf\n"));
+        return;
+    }
 
     /* Note: we add to align the IP header */