Index: /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c
===================================================================
--- /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c	(revision 16098)
+++ /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c	(revision 16099)
@@ -57,5 +57,6 @@
     } while (0)
 
-struct opts {
+struct opts
+{
     int  uid;
     int  gid;
@@ -106,5 +107,6 @@
     long long int val = strtoll (s, &endptr, base);
 
-    if (val < INT_MIN || val > INT_MAX || endptr < s + size) {
+    if (val < INT_MIN || val > INT_MAX || endptr < s + size)
+    {
         errno = ERANGE;
         panic_err ("could not convert %.*s to integer, result = %d",
@@ -139,12 +141,16 @@
         HONOSUID,
         HOSUID,
-        HOREMOUNT
+        HOREMOUNT,
+        HONOAUTO
     } handler_opt;
-    struct {
+    struct
+    {
         const char *name;
         handler_opt opt;
         int has_arg;
         const char *desc;
-    } handlers[] = {
+    } handlers[]
+    =
+    {
         {"rw",        HORW,        0, "mount read write (default)"},
         {"ro",        HORO,        0, "mount read only"},
@@ -166,8 +172,10 @@
         {"suid",      HOSUID,      0, 0 },
         {"remount",   HOREMOUNT,   0, 0 },
+        {"noauto",    HONOAUTO,    0, 0 },
         {NULL, 0, 0, NULL}
     }, *handler;
 
-    while (next) {
+    while (next)
+    {
         const char *val;
         size_t key_len, val_len;
@@ -175,20 +183,24 @@
         s = next;
         next = strchr (s, ',');
-        if (!next) {
+        if (!next)
+        {
             len = strlen (s);
         }
-        else {
+        else
+        {
             len = next - s;
             next += 1;
-            if (!*next) {
+            if (!*next)
                 next = 0;
-            }
         }
 
         val = NULL;
         val_len = 0;
-        for (key_len = 0; key_len < len; ++key_len) {
-            if (s[key_len] == '=') {
-                if (key_len + 1 < len) {
+        for (key_len = 0; key_len < len; ++key_len)
+        {
+            if (s[key_len] == '=')
+            {
+                if (key_len + 1 < len)
+                {
                     val = s + key_len + 1;
                     val_len = len - key_len - 1;
@@ -198,12 +210,16 @@
         }
 
-        for (handler = handlers; handler->name; ++handler) {
+        for (handler = handlers; handler->name; ++handler)
+        {
             size_t j;
             for (j = 0; j < key_len && handler->name[j] == s[j]; ++j)
                 ;
 
-            if (j == key_len && !handler->name[j]) {
-                if (handler->has_arg) {
-                    if (!(val && *val)) {
+            if (j == key_len && !handler->name[j])
+            {
+                if (handler->has_arg)
+                {
+                    if (!(val && *val))
+                    {
                         panic ("%.*s requires an argument (i.e. %.*s=<arg>)\n",
                                (int)len, s, (int)len, s);
@@ -265,5 +281,6 @@
                     break;
                 case HOIOCHARSET:
-                    if (val_len + 1 > sizeof (opts->nls_name)) {
+                    if (val_len + 1 > sizeof (opts->nls_name))
+                    {
                         panic ("iocharset name too long\n");
                     }
@@ -273,5 +290,6 @@
                 case HOCONVERTCP:
                     opts->convertcp = malloc (val_len + 1);
-                    if (!opts->convertcp) {
+                    if (!opts->convertcp)
+                    {
                         panic_err ("could not allocate memory");
                     }
@@ -279,4 +297,6 @@
                     opts->convertcp[val_len] = 0;
                     break;
+                case HONOAUTO:
+                    break;
                 }
                 break;
@@ -285,9 +305,11 @@
         }
 
-        if (!handler->name) {
+        if (!handler->name)
+        {
             fprintf (stderr, "unknown mount option `%.*s'\n", (int)len, s);
             fprintf (stderr, "valid options:\n");
 
-            for (handler = handlers; handler->name; ++handler) {
+            for (handler = handlers; handler->name; ++handler)
+            {
                 if (handler->desc)
                     fprintf (stderr, "  %-10s%s %s\n", handler->name,
@@ -374,12 +396,15 @@
 
     cd = iconv_open ("UTF-8", in_codeset);
-    if (cd == (iconv_t) -1) {
+    if (cd == (iconv_t) -1)
+    {
         panic_err ("could not convert share name, iconv_open `%s' failed",
                    in_codeset);
     }
 
-    while (ib) {
+    while (ib)
+    {
         size_t c = iconv (cd, &i, &ib, &o, &ob);
-        if (c == (size_t) -1) {
+        if (c == (size_t) -1)
+        {
             panic_err ("could not convert share name(%s) at %d",
                        host_name, (int)(strlen (host_name) - ib));
@@ -469,6 +494,8 @@
     CT_ASSERT(sizeof(gid_t) == sizeof(int));
 
-    while ((c = getopt (argc, argv, "rwno:h")) != -1) {
-        switch (c) {
+    while ((c = getopt (argc, argv, "rwno:h")) != -1)
+    {
+        switch (c)
+        {
             default:
                 fprintf (stderr, "unknown option `%c:%#x'\n", c, c);