Index: /trunk/src/VBox/Main/webservice/glue-jaxws.xsl
===================================================================
--- /trunk/src/VBox/Main/webservice/glue-jaxws.xsl	(revision 16123)
+++ /trunk/src/VBox/Main/webservice/glue-jaxws.xsl	(revision 16124)
@@ -53,6 +53,15 @@
  * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  *
  * This file is autogenerated by glue-jaxws.xsl, DO NOT EDIT!
@@ -441,6 +450,15 @@
  * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
- * Sun Microsystems, Inc. confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  *
  * This file is autogenerated by glue-jaxws.xsl, DO NOT EDIT!
Index: /trunk/src/VBox/Main/webservice/samples/java/axis/clienttest.java
===================================================================
--- /trunk/src/VBox/Main/webservice/samples/java/axis/clienttest.java	(revision 16123)
+++ /trunk/src/VBox/Main/webservice/samples/java/axis/clienttest.java	(revision 16124)
@@ -1,12 +1,21 @@
 
 /*
- *  Sample client for the VirtualBox webservice, written in Java.
- *  Best consumed in conjunction with the explanations in the VirtualBox
- *  User Manual, which describe in detail how to get this code running.
+ * Sample client for the VirtualBox webservice, written in Java.
+ * Best consumed in conjunction with the explanations in the VirtualBox
+ * User Manual, which describe in detail how to get this code running.
  *
- *  Copyright (C) 2008 Sun Microsystems, Inc.
+ * Copyright (C) 2008 Sun Microsystems, Inc.
  *
- *  Sun Microsystems, Inc. confidential
- *  All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 
Index: /trunk/src/VBox/Main/webservice/samples/java/jax-ws/clienttest.java
===================================================================
--- /trunk/src/VBox/Main/webservice/samples/java/jax-ws/clienttest.java	(revision 16123)
+++ /trunk/src/VBox/Main/webservice/samples/java/jax-ws/clienttest.java	(revision 16124)
@@ -5,8 +5,17 @@
  * with 'vboxwebsrv -t 1000' command, to calm down watchdog thread.
  *
- *  Copyright (C) 2008 Sun Microsystems, Inc.
+ * Copyright (C) 2008 Sun Microsystems, Inc.
  *
- *  Sun Microsystems, Inc. confidential
- *  All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
  */
 import com.sun.xml.ws.commons.virtualbox.*;
Index: /trunk/src/VBox/Main/webservice/websrv-python.xsl
===================================================================
--- /trunk/src/VBox/Main/webservice/websrv-python.xsl	(revision 16123)
+++ /trunk/src/VBox/Main/webservice/websrv-python.xsl	(revision 16124)
@@ -367,6 +367,15 @@
 <xsl:text># Copyright (C) 2008 Sun Microsystems, Inc.
 #
-# Sun Microsystems, Inc. confidential
-# All rights reserved
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+# Clara, CA 95054 USA or visit http://www.sun.com if you need
+# additional information or have any questions.
 #
 # This file is autogenerated from VirtualBox.xidl, DO NOT EDIT!